> For a complete page index, fetch https://developer.close.com/llms.txt

# Update an Opportunity Custom Field

PUT https://api.close.com/api/v1/custom_field/opportunity/{id}/
Content-Type: application/json

You can rename it, change its type, change whether it accepts multiple values or not, change whether editing its values is restricted to specific Roles, or update the options for a "choices" field type. The updated name will immediately appear in the Close UI and only valid values for the updated `type` will be returned by the Contact API.

Some of the type changes need to convert all of the existing values for a given Custom Field to the new type. When this is required, the response will include an additional `converting_to_type` field. When the conversion is done, `converting_to_type` will no longer be returned.

Reference: https://developer.close.com/api/resources/custom-fields/custom-fields-opportunity/update

## Authentication

- `Authorization` header (basic auth, required) — Use your API key as the username and leave the password empty.
- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `id` (string, required)

### Body (application/json)

This endpoint expects an any.

- `any`

## Response

### 200

Successful response

## Errors

### 400 Bad Request Error

Bad request, such as a validation error.

- `Custom_fields.opportunity_updateRequestBadRequestError`
  - ErrorMessage: ErrorMessage
  - ValidationErrors: ValidationErrors
  - NestedValidationErrors: NestedValidationErrors

### 401 Unauthorized Error

Authentication is missing or invalid.

- `error` (string, required) — Error message.

### 403 Forbidden Error

Forbidden. Also returned when the API key lacks the required scope (`error_code` is `insufficient_scope`) or is inactive (`error_code` is `inactive_api_key`).

- `Custom_fields.opportunity_updateRequestForbiddenError`
  - ErrorMessage: ErrorMessage
  - ApiKeyError: ApiKeyError

### 404 Not Found Error

Not found.

- `error` (string, required) — Error message.

### 429 Too Many Requests Error

Too many requests. The global API rate limiter returns an empty body. Other rate and operation limits return a `RateLimitError` body. Wait for the number of seconds in the `retry-after` header before retrying.

- `error` (RateLimitErrorError, required)

## Types

### ErrorMessage

Error with a message.

- `error` (string, required) — Error message.

### ValidationErrors

Validation errors with the path of each invalid field.

- `errors` (list of ValidationErrorsErrorsItems, required)

### NestedValidationErrors

Validation errors nested by field. Some endpoints return only `errors` or only `field-errors`.

- `errors` (list of string, optional) — Errors that don't apply to a single field.
- `field-errors` (map from string to any, optional) — Errors keyed by field name. Each value is a message, a list of messages, or a nested object of the same shape for nested fields.

### ApiKeyError

The API key lacks the scope the request requires, or is inactive.

- `error` (string, required)
- `error_code` (enum, required)
  - Allowed values: `insufficient_scope`, `inactive_api_key`
- `required_scope` (string, optional) — API key scope the request requires. Present when `error_code` is `insufficient_scope`.

### RateLimitErrorError

- `message` (string, required, nullable)
- `rate_reset` (string, required) — Number of seconds until the rate limit resets.
- `allowed_limit` (integer, optional) — Maximum number of bulk actions allowed. Present when the bulk action limit was hit.
- `bulk_action_count` (integer, optional) — Number of bulk actions running. Present when the bulk action limit was hit.

### ValidationErrorsErrorsItems

- `field` (list of ValidationErrorsErrorsItemsFieldItems, required) — Path of the invalid field. Empty for errors that don't apply to a field.
- `msg` (string, required)

### ValidationErrorsErrorsItemsFieldItems

- integer
- string

## Examples

**Request**

```json
{
  "name": "Contract"
}
```

**Response**

```json
{
  "accepts_multiple_values": false,
  "choices": null,
  "created_by": "user_N6KhMpzHRCYQHdn4gRNIFNN5JExnsrprKA6ekxM63XA",
  "date_created": "2020-02-07T11:54:50.770000+00:00",
  "date_updated": "2020-02-07T12:03:53.995000+00:00",
  "description": "Link to the contract for this opportunity",
  "editable_with_roles": [],
  "id": "cf_j0P7kHmgFTZZnYBFtyPSZ3uQw4dpW8xKcW7Krps8atj",
  "name": "Contract",
  "organization_id": "orga_RbREgmiiwcr1w2b4cOnCMQaQPSIFxMqAD2Dh243uxcH",
  "type": "text",
  "updated_by": "user_N6KhMpzHRCYQHdn4gRNIFNN5JExnsrprKA6ekxM63XA"
}
```

**SDK Code**

```python
import requests

url = "https://api.close.com/api/v1/custom_field/opportunity/:id/"

payload = { "name": "Contract" }
headers = {
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers, auth=("<CLOSE_API_KEY>", ""))

print(response.json())
```

```javascript
const url = 'https://api.close.com/api/v1/custom_field/opportunity/:id/';
const credentials = btoa("<CLOSE_API_KEY>:");

const options = {
  method: 'PUT',
  headers: {Authorization: `Basic ${credentials}`, 'Content-Type': 'application/json'},
  body: '{"name":"Contract"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.close.com/api/v1/custom_field/opportunity/:id/"

	payload := strings.NewReader("{\n  \"name\": \"Contract\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.SetBasicAuth("<CLOSE_API_KEY>", "")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.close.com/api/v1/custom_field/opportunity/:id/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request.basic_auth("<CLOSE_API_KEY>", "")
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Contract\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.close.com/api/v1/custom_field/opportunity/:id/")
  .basicAuth("<CLOSE_API_KEY>", "")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Contract\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.close.com/api/v1/custom_field/opportunity/:id/', [
  'body' => '{
  "name": "Contract"
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
    'auth' => ['<CLOSE_API_KEY>', ''],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://api.close.com/api/v1/custom_field/opportunity/:id/");
client.Authenticator = new HttpBasicAuthenticator("<CLOSE_API_KEY>", "");
var request = new RestRequest(Method.PUT);

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Contract\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```